/*
 * DBRecipientFetcher.java
 *
 * Created on 05 May 2005, 21:34
 */

package jim.common.mail;

import java.sql.*;
import javax.sql.DataSource;
import java.util.*;
import jim.util.SqlUtils;

/**
 *
 * @author  briggsj
 */
public class DBRecipientFetcher {
    
    private SqlUtils sql = null;
    private String keyName;
    private String selectAllRows;
    private String selectOneRow;
    
    /** Creates a new instance of DBRecipientFetcher */
    public DBRecipientFetcher(SqlUtils sql, String tableName, String keyName, String valueName) {
        init(sql, tableName, keyName, valueName);
    }
    
    private void init(SqlUtils sql, String tableName, String keyName, String valueName) {
        this.keyName = keyName;
        String condition = "WHERE (ANNUM = 'ey2005' AND VISITED IS NULL)";
        this.selectOneRow = "SELECT " + keyName + ", " + valueName + " FROM " + tableName + " " + condition + " AND (lower(" + keyName + ") = lower(?))";
        this.selectAllRows = "SELECT " + keyName + ", " + valueName + " FROM " + tableName + " " + condition;
        this.sql = sql;
    }
    
    private List /*Map*/ pool = null;
    
    /**
     * Load all strings from the database
     * @throws MessageException if there are database problems
     */
    public void fetchAllStudentsByCourse(List courses) throws RecipientException {
        StringBuffer courseList = makeCourseList(courses);
        String select = new String(selectAllRows);
        select += "AND (COURSE_CODE IN " + courseList + ")";
        try {
            ResultSet rs = sql.selectRS(select);
            pool = sql.RStoMapList(rs);
            //            while (rs.next()) {
            //                Map all = sql.RStoMap(rs);
            //                this.pool.put(all.get(keyName), all);
            //            }
            rs.close();
        } catch (SQLException e) {
            throw new RecipientException("Problems reading components from database", e);
        }
    }

    /**
     * @param courses
     * @return
     */
    private StringBuffer makeCourseList(final List courses) {
        Iterator it = courses.iterator();
        StringBuffer courseList = new StringBuffer(courses.size()*12);
        courseList.append("[");
        boolean first = true;
        while (it.hasNext()) {
            if (!first) {
                courseList.append(", ");
            } else {
                first = false;
            }
            courseList.append("'" + (String)it.next() + "'");
        }
        return courseList;
    }
    
    /*
     * Get addresses of people in pool
     */
    public List getAddresses() {
        return pool;
    }
    
    public List getCourses(String annum) throws SQLException {
        String select = "SELECT * FROM COURSE WHERE ANNUM = ?";
        List courses = sql.selectList(select, new Object[]{annum});
        return courses;
    }
}
