/*
 * users.java
 *
 * Created on 28 January 2004, 21:57
 */

package jim.util;

import java.sql.*;

/**
 *
 * @author  briggsj
 */
public class UserDAO {
    
    /** Holds value of property conn. */
    private Connection conn = null;
    
    //    /** Creates a new instance of users */
    //    public UserDAO () {
    //    }
    
    public UserDAO (Connection conn) {
        this.conn = conn;
    }
    
    public void insert (LoginBean login) throws Exception {
        String prep = "INSERT INTO USERS VALUES (?, ?, ?, ?, ?, ?)";
        PreparedStatement statement;
        try {
            statement = conn.prepareStatement (prep);
            statement.setString (1, login.getUsername ());
            statement.setString (2, login.getPassword ());
            statement.setInt (3, SqlUtils.nextval (conn, "S_USR"));
            statement.setString(4, login.getForename());
            statement.setString(5, login.getLastname());
            statement.setString(6, login.getLabel());
            statement.executeUpdate ();
        } catch (Exception e) {
            throw new Exception ("Cannot insert new user: " + e.getMessage (), e);
        }
    }
    
    public void changePassword (LoginBean login) throws Exception {
        String prep = "UPDATE users SET password = ? WHERE idno = ?";
        PreparedStatement statement;
        statement = conn.prepareStatement(prep);
        statement.setString(1, login.getPassword ());
        statement.setInt(2, login.getIdno ());
        int rows = statement.executeUpdate ();
        if (rows != 1) {
            throw new Exception("changePassword: rows affected = " + rows);
        }   
    }
    
    public LoginBean getResult (LoginBean login) throws Exception {
        String username = login.getUsername ();
        String password = login.getPassword ();
        
        String query = new String ("SELECT username, idno, forename, lastname FROM USERS "
        + "WHERE lower(username) = ? AND lower(password) = ?");
        
        PreparedStatement statement;
        ResultSet rs;
        String user = null;
        int idno = 0;
        try {
            statement = conn.prepareStatement (query);
            statement.setString (1, username);
            statement.setString (2, password);
            rs = statement.executeQuery ();
            while (rs.next ()) {
                user = rs.getString ("username");
                idno = rs.getInt ("idno");
                login.setForename( rs.getString ("forename"));
                login.setLastname( rs.getString ("lastname"));
            }
        } catch (Exception e) {
            throw new Exception ("Query: " + query + ":: " + e.getMessage (), e);
        }
        
        login.setIdno (idno);
        return login;
    }
    
    /** Setter for property conn.
     * @param conn New value of property conn.
     *
     */
    public void setConn (Connection conn) {
        this.conn = conn;
    }
    
}
